﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace soutez_402
{
    public partial class Form1 : Form
    {
        public int pocetBodu = 0;
        public int oznacenyX = 999, oznacenyY = 999;
        public int indexRadove = 0;
        public String[] soubor;
        public int[,] poleDesky = new int[8, 8];
        public int[] dalsiRada = new int[8];
        public Brush[] barvyKamenu = new Brush[7];
        public List<int> kOdebraniX = new List<int>();
        public List<int> kOdebraniY = new List<int>();
        public TimeSpan casovac;
        public bool zacaloSe = false;
        public int sekundyDoKonce;
        public Form1()
        {
            barvyKamenu[0] = Brushes.Red;
            barvyKamenu[1] = Brushes.Green;
            barvyKamenu[2] = Brushes.Blue;
            barvyKamenu[3] = Brushes.White;
            barvyKamenu[4] = Brushes.Yellow;
            barvyKamenu[5] = Brushes.DarkViolet;
            barvyKamenu[6] = Brushes.Black; //momentalne prazdny kamen

            InitializeComponent();
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    poleDesky[i, j] = 1;
                }
                dalsiRada[i] = 1;
            }
        }

        private void vykresliPlochu(Graphics g)
        {
            int aktualniBarva = 0;
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    aktualniBarva = poleDesky[i, j];
                    g.FillRectangle(barvyKamenu[aktualniBarva - 1], i * 50, j * 50, 45, 45);
                }
            }
            Pen oznaceni = new Pen(Color.Black, 2);
            g.DrawRectangle(oznaceni, oznacenyX * 50, oznacenyY * 50, 45, 45);
        }
        private void vykresliRadu(Graphics g)
        {
            int aktualniBarva = 0;
            for (int i = 0; i < 8; i++)
            {
                    aktualniBarva = dalsiRada[i];
                    g.FillRectangle(barvyKamenu[aktualniBarva - 1], i * 50, 0, 45, 45);
            }
        }
        private void hraci_plocha_Paint(object sender, PaintEventArgs e)
        {
            vykresliPlochu(e.Graphics);
        }

        private void naplnitPole()
        {
            for (int i = 0; i < 8; i++)
            {
                for (int j = 0; j < 8; j++)
                {
                    poleDesky[i, j] = Convert.ToInt32(soubor[i][j].ToString());
                }
            }
            for (int i = 0; i < 8; i++)
            {
                dalsiRada[i] = Convert.ToInt32(soubor[i + 8][0].ToString());
            }

        }

        private void nacistBtn_Click(object sender, EventArgs e)
        {
            OpenFileDialog souborDialog = new OpenFileDialog(); // dialog pro oznaceni souboru
            souborDialog.Multiselect = false; //lze vybrat pouze jeden soubor
            DialogResult vybran = souborDialog.ShowDialog();

            if (vybran == DialogResult.OK)
            {
                soubor = File.ReadAllLines(souborDialog.FileName, Encoding.Default);
                naplnitPole();
                hraci_plocha.Invalidate();
                nahradniRada.Invalidate();
            }
            else
            {
                MessageBox.Show("Načítání ze souboru bylo zrušeno uživatelem!");
            }
            oznacenyX = 999;
            oznacenyY = 999;
        }

        private void hraci_plocha_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.X / 50 <= 7 && e.Y / 50 <= 7)
            {
                if (oznacenyX == e.X / 50 && oznacenyY == e.Y / 50)
                {
                    oznacenyX = 999;
                    oznacenyY = 999;
                }
                else
                {
                    if (oznacenyX != 999)
                    {
                        presunKamene(oznacenyX, oznacenyY, e.X / 50, e.Y / 50);
                        oznacenyX = 999;
                        oznacenyY = 999;

                    }
                    else
                    {
                        oznacenyX = e.X / 50;
                        oznacenyY = e.Y / 50;
                    }
                }
                hraci_plocha.Invalidate();
            }
        }

        private bool moznyTah()
        {
            bool nalezeno = false;
            int hledanaBarva;
            int kolikRada = 0;
            int zacatekSloupceX = 0, zacatekSloupceY = 0;
            for (int i = 0; i < 8; i++) //hledani ve sloupci
            {
                kolikRada = 0;
                hledanaBarva = poleDesky[i, 0];
                for (int j = 0; j < 8; j++)
                {
                    if (poleDesky[i, j] == hledanaBarva)
                    {
                        kolikRada++;
                    }
                    else
                    {
                        if (kolikRada >= 3)
                        {
                            nalezeno = true;
                            for (int index = zacatekSloupceY; index < zacatekSloupceY+kolikRada; index++)
                            {
                                kOdebraniX.Add(i);
                                kOdebraniY.Add(index);
                            }
                        }
                        kolikRada = 1;
                        hledanaBarva = poleDesky[i, j];
                        zacatekSloupceX = i; zacatekSloupceY = j;
                    }
                }
            }
            for (int j = 0; j < 8; j++) //hledani v radku
            {
                kolikRada = 0;
                hledanaBarva = poleDesky[0, j];
                for (int i = 0; i < 8; i++)
                {
                    if (poleDesky[i, j] == hledanaBarva)
                    {
                        kolikRada++;
                    }
                    else
                    {
                        if (kolikRada >= 3)
                        {
                            nalezeno = true;
                            for (int index = zacatekSloupceY; index < zacatekSloupceY+kolikRada; index++)
                            {
                                kOdebraniX.Add(i);
                                kOdebraniY.Add(index);
                            }
                        }
                        kolikRada = 1;
                        hledanaBarva = poleDesky[i, j];
                        zacatekSloupceX = j; zacatekSloupceY = i;
                    }
                }
            }
            return nalezeno;
        }

        private void startWithoutBtn_Click(object sender, EventArgs e)
        {
            cas.Text = "Bez limitu";
            zacaloSe = true;
            sekundyTmr.Stop();
        }

        private void startWithBtn_Click(object sender, EventArgs e)
        {
            zacaloSe = true;
            try
            {
                int minuty = Convert.ToInt32(Microsoft.VisualBasic.Interaction.InputBox("Zadejte počet minut",
                           "Minuty",
                           "0",
                           0,
                           0));
                int sekundy = Convert.ToInt32(Microsoft.VisualBasic.Interaction.InputBox("Zadejte počet sekund",
                           "Sekundy",
                           "0",
                           0,
                           0));
                sekundyDoKonce = minuty * 60 + sekundy;
                sekundyTmr.Start();
            }
            catch
            {
                MessageBox.Show("Špatně zadáno");
            }
        }

        private void sekundy_Tick(object sender, EventArgs e)
        {
            
            sekundyDoKonce--;
            cas.Text = sekundyDoKonce / 60 + ":" + sekundyDoKonce % 60;
            if (sekundyDoKonce == 0) {
                sekundyTmr.Stop();
                MessageBox.Show("Konec časového limitu!");
            }
            zacaloSe = false;
        }

        private void presunKamene(int zX, int zY, int naX, int naY)
        {
            if (Math.Abs(zX - naX) <= 1 && Math.Abs(zY - naY) <= 1)
            {
                int barvaZ = poleDesky[zX, zY];
                int barvaNa = poleDesky[naX, naY];

                poleDesky[zX, zY] = barvaNa;
                poleDesky[naX, naY] = barvaZ;

                if (!moznyTah())
                {
                    poleDesky[zX, zY] = barvaZ;
                    poleDesky[naX, naY] = barvaNa;
                    MessageBox.Show("Nelze zahrát");
                }
                else
                {
                    odeberKameny();
                }
            }
            else
            {
                MessageBox.Show("Nemožný tah");
            }
        }

        private void nahradniRada_paint(object sender, PaintEventArgs e)
        {
            vykresliRadu(e.Graphics);
        }

        private void odeberKameny()
        {
            foreach(int test in kOdebraniX)
            {
                foreach (int dru in kOdebraniY)
                {
                    
                }
            }
        }
    }
}
